%% bare_conf.tex
%% V1.3
%% 2007/01/11
%% by Michael Shell
%% See:
%% http://www.michaelshell.org/
%% for current contact information.
%%
%% This is a skeleton file demonstrating the use of IEEEtran.cls
%% (requires IEEEtran.cls version 1.7 or later) with an IEEE conference paper.
%%PushPull:Streaming
%% Support sites:
%% http://www.michaelshell.org/tex/ieeetran/
%% http://www.ctan.org/tex-archive/macros/latex/contrib/IEEEtran/
%% and
%% http://www.ieee.org/

%%*************************************************************************
%% Legal Notice:
%% This code is offered as-is without any warranty either expressed or
%% implied; without even the implied warranty of MERCHANTABILITY or
%% FITNESS FOR A PARTICULAR PURPOSE! 
%% User assumes all risk.
%% In no event shall IEEE or any contributor to this code be liable for
%% any damages or losses, including, but not limited to, incidental,
%% consequential, or any other damages, resulting from the use or misuse
%% of any information contained here.
%%
%% All comments are the opinions of their respective authors and are not
%% necessarily endorsed by the IEEE.
%%
%% This work is distributed under the LaTeX Project Public License (LPPL)
%% ( http://www.latex-project.org/ ) version 1.3, and may be freely used,
%% distributed and modified. A copy of the LPPL, version 1.3, is included
%% in the base LaTeX documentation of all distributions of LaTeX released
%% 2003/12/01 or later.
%% Retain all contribution notices and credits.
%% ** Modified files should be clearly indicated as such, including  **
%% ** renaming them and changing author support contact information. **
%%
%% File list of work: IEEEtran.cls, IEEEtran_HOWTO.pdf, bare_adv.tex,
%%                    bare_conf.tex, bare_jrnl.tex, bare_jrnl_compsoc.tex
%%*************************************************************************

% *** Authors should verify (and, if needed, correct) their LaTeX system  ***
% *** with the testflow diagnostic prior to trusting their LaTeX platform ***
% *** with production work. IEEE's font choices can trigger bugs that do  ***
% *** not appear when using other class files.                            ***
% The testflow support page is at:
% http://www.michaelshell.org/tex/testflow/



% Note that the a4paper option is mainly intended so that authors in
% countries using A4 can easily print to A4 and see how their papers will
% look in print - the typesetting of the document will not typically be
% affected with changes in paper size (but the bottom and side margins will).
% Use the testflow package mentioned above to verify correct handling of
% both paper sizes by the user's LaTeX system.
%
% Also note that the "draftcls" or "draftclsnofoot", not "draft", option
% should be used if it is desired that the figures are to be displayed in
% draft mode.
%
\documentclass[conference]{IEEEtran}
%\documentclass[10pt]{IEEEtran}
\usepackage{times}
\usepackage{url}
\usepackage{caption} 
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{textcomp}
\usepackage{gensymb}
\usepackage{float}
\usepackage{caption} 
\usepackage{subcaption}
\usepackage{array}
\usepackage{listings}

\captionsetup{font=footnotesize,justification=centering,labelsep=period}

% Add the compsoc option for Computer Society conferences.
%
% If IEEEtran.cls has not been installed into the LaTeX system files,
% manually specify the path to it like:
% \documentclass[conference]{../sty/IEEEtran}





% Some very useful LaTeX packages include:
% (uncomment the ones you want to load)


% *** MISC UTILITY PACKAGES ***
%
%\usepackage{ifpdf}
% Heiko Oberdiek's ifpdf.sty is very useful if you need conditional
% compilation based on whether the output is pdf or dvi.
% usage:
% \ifpdf
%   % pdf code
% \else
%   % dvi code
% \fi
% The latest version of ifpdf.sty can be obtained from:
% http://www.ctan.org/tex-archive/macros/latex/contrib/oberdiek/
% Also, note that IEEEtran.cls V1.7 and later provides a builtin
% \ifCLASSINFOpdf conditional that works the same way.
% When switching from latex to pdflatex and vice-versa, the compiler may
% have to be run twice to clear warning/error messages.






% *** CITATION PACKAGES ***
%
%\usepackage{cite}
% cite.sty was written by Donald Arseneau
% V1.6 and later of IEEEtran pre-defines the format of the cite.sty package
% \cite{} output to follow that of IEEE. Loading the cite package will
% result in citation numbers being automatically sorted and properly
% "compressed/ranged". e.g., [1], [9], [2], [7], [5], [6] without using
% cite.sty will become [1], [2], [5]--[7], [9] using cite.sty. cite.sty's
% \cite will automatically add leading space, if needed. Use cite.sty's
% noadjust option (cite.sty V3.8 and later) if you want to turn this off.
% cite.sty is already installed on most LaTeX systems. Be sure and use
% version 4.0 (2003-05-27) and later if using hyperref.sty. cite.sty does
% not currently provide for hyperlinked citations.
% The latest version can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/cite/
% The documentation is contained in the cite.sty file itself.






% *** GRAPHICS RELATED PACKAGES ***
%
\ifCLASSINFOpdf
  \usepackage[pdftex]{graphicx}
  % declare the path(s) where your graphic files are
  % and their extensions so you won't have to specify these with
  % every instance of \includegraphics
  \DeclareGraphicsExtensions{.pdf,.jpeg,.png}
\else
  % or other class option (dvipsone, dvipdf, if not using dvips). graphicx
  % will default to the driver specified in the system graphics.cfg if no
  % driver is specified.
  % \usepackage[dvips]{graphicx}
  % declare the path(s) where your graphic files are
  % \graphicspath{{../eps/}}
  % and their extensions so you won't have to specify these with
  % every instance of \includegraphics
  % \DeclareGraphicsExtensions{.eps}
\fi
% graphicx was written by David Carlisle and Sebastian Rahtz. It is
% required if you want graphics, photos, etc. graphicx.sty is already
% installed on most LaTeX systems. The latest version and documentation can
% be obtained at: 
% http://www.ctan.org/tex-archive/macros/latex/required/graphics/
% Another good source of documentation is "Using Imported Graphics in
% LaTeX2e" by Keith Reckdahl which can be found as epslatex.ps or
% epslatex.pdf at: http://www.ctan.org/tex-archive/info/
%
% latex, and pdflatex in dvi mode, support graphics in encapsulated
% postscript (.eps) format. pdflatex in pdf mode supports graphics
% in .pdf, .jpeg, .png and .mps (metapost) formats. Users should ensure
% that all non-photo figures use a vector format (.eps, .pdf, .mps) and
% not a bitmapped formats (.jpeg, .png). IEEE frowns on bitmapped formats
% which can result in "jaggedy"/blurry rendering of lines and letters as
% well as large increases in file sizes.
%
% You can find documentation about the pdfTeX application at:
% http://www.tug.org/applications/pdftex





% *** MATH PACKAGES ***
%
\usepackage[cmex10]{amsmath}
% A popular package from the American Mathematical Society that provides
% many useful and powerful commands for dealing with mathematics. If using
% it, be sure to load this package with the cmex10 option to ensure that
% only type 1 fonts will utilized at all point sizes. Without this option,
% it is possible that some math symbols, particularly those within
% footnotes, will be rendered in bitmap form which will result in a
% document that can not be IEEE Xplore compliant!
%
% Also, note that the amsmath package sets \interdisplaylinepenalty to 10000
% thus preventing page breaks from occurring within multiline equations. Use:
%\interdisplaylinepenalty=2500
% after loading amsmath to restore such page breaks as IEEEtran.cls normally
% does. amsmath.sty is already installed on most LaTeX systems. The latest
% version and documentation can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/required/amslatex/math/





% *** SPECIALIZED LIST PACKAGES ***
%
%\usepackage{algorithmic}
% algorithmic.sty was written by Peter Williams and Rogerio Brito.
% This package provides an algorithmic environment fo describing algorithms.
% You can use the algorithmic environment in-text or within a figure
% environment to provide for a floating algorithm. Do NOT use the algorithm
% floating environment provided by algorithm.sty (by the same authors) or
% algorithm2e.sty (by Christophe Fiorio) as IEEE does not use dedicated
% algorithm float types and packages that provide these will not provide
% correct IEEE style captions. The latest version and documentation of
% algorithmic.sty can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/algorithms/
% There is also a support site at:
% http://algorithms.berlios.de/index.html
% Also of interest may be the (relatively newer and more customizable)
% algorithmicx.sty package by Szasz Janos:
% http://www.ctan.org/tex-archive/macros/latex/contrib/algorithmicx/




% *** ALIGNMENT PACKAGES ***
%
%\usepackage{array}
% Frank Mittelbach's and David Carlisle's array.sty patches and improves
% the standard LaTeX2e array and tabular environments to provide better
% appearance and additional user controls. As the default LaTeX2e table
% generation code is lacking to the point of almost being broken with
% respect to the quality of the end results, all users are strongly
% advised to use an enhanced (at the very least that provided by array.sty)
% set of table tools. array.sty is already installed on most systems. The
% latest version and documentation can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/required/tools/


%\usepackage{mdwmath}
%\usepackage{mdwtab}
% Also highly recommended is Mark Wooding's extremely powerful MDW tools,
% especially mdwmath.sty and mdwtab.sty which are used to format equations
% and tables, respectively. The MDWtools set is already installed on most
% LaTeX systems. The lastest version and documentation is available at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/mdwtools/


% IEEEtran contains the IEEEeqnarray family of commands that can be used to
% generate multiline equations as well as matrices, tables, etc., of high
% quality.


%\usepackage{eqparbox}
% Also of notable interest is Scott Pakin's eqparbox package for creating
% (automatically sized) equal width boxes - aka "natural width parboxes".
% Available at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/eqparbox/





%\usepackage[tight,footnotesize]{subfigure}
% subfigure.sty was written by Steven Douglas Coc
% *** SUBFIGURE PACKAGES ***hran. This package makes it
% easy to put subfigures in your figures. e.g., "Figure 1a and 1b". For IEEE
% work, it is a good idea to load it with the tight package option to reduce
% the amount of white space around the subfigures. subfigure.sty is already
% installed on most LaTeX systems. The latest version and documentation can
% be obtained at:
% http://www.ctan.org/tex-archive/obsolete/macros/latex/contrib/subfigure/
% subfigure.sty has been superceeded by subfig.sty.



%\usepackage[caption=false]{caption}
%\usepackage[font=footnotesize]{subfig}
% subfig.sty, also written by Steven Douglas Cochran, is the modern
% replacement for subfigure.sty. However, subfig.sty requires and
% automatically loads Axel Sommerfeldt's caption.sty which will override
% IEEEtran.cls handling of captions and this will result in nonIEEE style
% figure/table captions. To prevent this problem, be sure and preload
% caption.sty with its "caption=false" package option. This is will preserve
% IEEEtran.cls handing of captions. Version 1.3 (2005/06/28) and later 
% (recommended due to many improvements over 1.2) of subfig.sty supports
% the caption=false option directly:
%\usepackage[caption=false,font=footnotesize]{subfig}
%
% The latest version and documentation can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/subfig/
% The latest version and documentation of caption.sty can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/caption/




% *** FLOAT PACKAGES ***
%
%\usepackage{fixltx2e}
% fixltx2e, the successor to the earlier fix2col.sty, was written by
% Frank Mittelbach and David Carlisle. This package corrects a few problems
% in the LaTeX2e kernel, the most notable of which is that in current
% LaTeX2e releases, the ordering of single and double column floats is not
% guaranteed to be preserved. Thus, an unpatched LaTeX2e can allow a
% single column figure to be placed prior to an earlier double column
% figure. The latest version and documentation can be found at:
% http://www.ctan.org/tex-archive/macros/latex/base/



%\usepackage{stfloats}
% stfloats.sty was written by Sigitas Tolusis. This package gives LaTeX2e
% the ability to do double column floats at the bottom of the page as well
% as the top. (e.g., "\begin{figure*}[!b]" is not normally possible in
% LaTeX2e). It also provides a command:
%\fnbelowfloat
% to enable the placement of footnotes below bottom floats (the standard
% LaTeX2e kernel puts them above bottom floats). This is an invasive package
% which rewrites many portions of the LaTeX2e float routines. It may not work
% with other packages that modify the LaTeX2e float routines. The latest
% version and documentation can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/sttools/
% Documentation is contained in the stfloats.sty comments as well as in the
% presfull.pdf file. Do not use the stfloats baselinefloat ability as IEEE
% does not allow \baselineskip to stretch. Authors submitting work to the
% IEEE should note that IEEE rarely uses double column equations and
% that authors should try to avoid such use. Do not be tempted to use the
% cuted.sty or midfloat.sty packages (also by Sigitas Tolusis) as IEEE does
% not format its papers in such ways.



% *** PDF, URL AND HYPERLINK PACKAGES ***
%
%\usepackage{url}
% url.sty was written by Donald Arseneau. It provides better support for
% handling and breaking URLs. url.sty is already installed on most LaTeX
% systems. The latest version can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/misc/
% Read the url.sty source comments for usage information. Basically,
% \url{my_url_here}.





% *** Do not adjust lengths that control margins, column widths, etc. ***
% *** Do not use packages that alter fonts (such as pslatex).         ***
% There should be no need to do such things with IEEEtran.cls V1.6 and later.
% (Unless specifically asked to do so by the journal or conference you plan
% to submit to, of course. )

%\raggedbottom
%My Custom style to suppress space in text paragraph


% correct bad hyphenation here
\hyphenation{op-tical net-works semi-conduc-tor}

%\parskip 6pt plus 2pt minus 1pt
%\parskip 3pt plus 2pt minus 1pt

%\pagestyle{empty}

\IEEEoverridecommandlockouts 
\IEEEpubid{\makebox[\columnwidth]{978-1-5090-6501-1/17/\$31.00~\copyright~2017 IEEE \hfill} 
	\hspace{\columnsep}\makebox[\columnwidth]{ }}

\begin{document}
\pagenumbering{gobble}
%
% paper title
% can use linebreaks \\ within to get better formatting as desired
\title{\textbf{\Large A Network-centric TCP for Interactive Video Delivery Networks (VDN) \\[-1.5ex]}}

% author names and affiliations
% use a multiple column layout for up to three different
% affiliations
\author{\IEEEauthorblockN{MD Iftakharul Islam and Javed I Khan}
\IEEEauthorblockA{Kent State University\\
Email: {\tt mislam4@kent.edu, javed@cs.kent.edu}}}

% conference papers do not typically use \thanks and this command
% is locked out in conference mode. If really needed, such as for
% the acknowledgment of grants, issue a \IEEEoverridecommandlockouts
% after \documentclass

% for over three affiliations, or if they all won't fit within the width
% of the page, use this alternative format:
% 
%\author{\IEEEauthorblockN{Michael Shell\IEEEauthorrefmark{1},
%Homer Simpson\IEEEauthorrefmark{2},
%James Kirk\IEEEauthorrefmark{3}, 
%Montgomery Scott\IEEEauthorrefmark{3} and
%Eldon Tyrell\IEEEauthorrefmark{4}}
%\IEEEauthorblockA{\IEEEauthorrefmark{1}School of Electrical and Computer Engineering\\
%Georgia Institute of Technology,
%Atlanta, Georgia 30332--0250\\ Email: see http://www.michaelshell.org/contact.html}
%\IEEEauthorblockA{\IEEEauthorrefmark{2}Twentieth Century Fox, Springfield, USA\\
%Email: homer@thesimpsons.com}
%\IEEEauthorblockA{\IEEEauthorrefmark{3}Starfleet Academy, San Francisco, California 96678-2391\\
%Telephone: (800) 555--1212, Fax: (888) 555--1212}
%\IEEEauthorblockA{\IEEEauthorrefmark{4}Tyrell Inc., 123 Replicant Street, Los Angeles, California 90210--4321}}




% use for special paper notices
%\IEEEspecialpapernotice{(Invited Paper)}

%copyright
%\IEEEoverridecommandlockouts
%\IEEEpubid{\hspace{-\columnwidth}978-1-5090-6501-1/17/\$31.00 ©2017 IEEE}


% make the title area
\maketitle


\begin{abstract}
%\boldmath
Interactive video streaming requires very low latency and high throughput. Traditional latency based congestion control algorithm performs poorly in fairness. This results in very poor video quality to adaptive video streaming. Programmable router architecture such as RMT and dRMT enable us to solve the problem by designing a network controller in the routers. This paper presents a network-centric TCP where sending rate of the network is calculated from the network rather than the host. Routers along the path uses a \textit{proportional integral (PI)}  controller to calculate the sending rate in order to reduce the queuing delay. The routers also divide the available throughput fairly among the flows. NC-TCP has been designed for interactive video delivery network (VDN) where the interactive video flows compete among themselves. Such differentiated service obviates the need for \textit{TCP-friendliness}. NC-TCP uses a rate-based congestion control rather than traditional window-based mechanism. It uses \textit{TCP-pacing} for regulating the sending rate. We have implemented NC-TCP in Linux kernel. We have shown that NC-TCP on a ARM Cotex-M3 based based NPU can achieve 4.7 Tb/s. To evaluate NC-TCP, we have developed a TCP-based adaptive video streaming application based on GStreamer. We have evaluated NC-TCP in Mininet. We have compared the performance of NC-TCP to that of TCP Inigo and XCP. Our experimental results show that both NC-TCP and XCP outperforms delay-based congestion control, TCP Inigo in interactive VDN. NC-TCP also results in lower queuing delay compared XCP in interactive VDN.

\end{abstract}
% IEEEtran.cls defaults to using nonbold math in the Abstract.
% This preserves the distinction between vectors and scalars. However,
% if the conference you are submitting to favors bold math in the abstract,
% then you can use LaTeX's standard command \boldmath at the very start
% of the abstract to achieve this. Many IEEE journals/conferences frown on
% math in the abstract anyway.

% no keywords

\begin{IEEEkeywords}
Network-centric Congestion Control; XCP; dRMT; NPU; Zero Overhead Linux; User Space Packet Processing; ARM Cortex-M3%
\end{IEEEkeywords}



% For peer review papers, you can put extra information on the cover
% page as needed:
% \ifCLASSOPTIONpeerreview
% \begin{center} \bfseries EDICS Category: 3-BBND \end{center}
% \fi
%
% For peerreview papers, this IEEEtran command inserts a page break and
% creates the second title. It will be ignored for other modes.
\IEEEpeerreviewmaketitle



\section{Introduction}
% no \IEEEPARstart
Interactive video streaming over the Internet are expected to behave in a TCP-friendly manner. For example, Skype uses a TCP-friendly congestion control algorithm for video conferencing \cite{zhang2012profiling}. However competing with TCP flows adversely affect interactive video streaming. Loss-based congestion control of TCP fills up the router buffer (\textit{bufferbloat problem}) which increases delay. Again interactive video streaming also traditionally employs delay based congestion control algorithm which loses throughput to loss-based congestion control algorithm \cite{grieco2004performance}. Recent advances in network virtualization and differentiated service enable us to isolate interactive video traffic from other best effort services \cite{anderson2005overcoming, matta2000differentiated}. This obviates the need for TCP-friendliness and enables us to design congestion control algorithm where interactive video streaming competes among themselves.

Congestion control for real-time communication aims to minimize the delay. The first proposed delay based congestion control algorithm used  Round Trip Time (RTT) to infer congestion. In this case, a sender uses RTT characteristics to infer a delay threshold. The algorithms use these approach include TCP Vegas \cite{brakmo1995tcp} and TCP FAST \cite{wei2006fast}. It has been shown that RTT based congestion control results in lower link utilization in the presence of reverse traffic, which inflates queues in the backward path\cite{grieco2004performance}. To solve this problem, LEDBAT \cite{rossi2010ledbat} employs one-way delay to rule out the sensitivity to the reverse path congestion. These approach however suffers \textit{latecomer effect} : when two flows
share the same bottleneck, the second flow may starve the first one \cite{carofiglio2010quest}. Recently RTT gradient (change of RTT over time) has been employed to overcome the latecomer effect. Examples of such congestion control are TCP CDG \cite{hayes2011revisiting} and TCP Igino \cite{shewmaker2016tcp}. TCP CDG regulates the sending rate based on RTT gradient whereas TCP Igino regulates the sending rate based on one-way delay gradient. Google Hangout also uses one-way delay gradient based congestion control algorithm over RTP/RTCP \cite{lundin2012google}. 

Although delay-gradient based congestion control algorithms have been widely used for interactive video streaming, it has shown that they suffer from fairness issue \cite{de2013experimental, carlucci2016congestion}. It is important to mention that if flows cannot share throughput fairly, it results in poor video quality for the flows. Recent advances in software defined networks (SDN) however has a potential to solve this problem. Programmable routers \cite{bosshart2013forwarding, chole2017drmt} can provide us with explicit feedback from network. XCP\cite{katabi2002internet} is the first attempt in direction where explicit rate is assigned by the router based on persistent queuing delay and spare capacity of the bottleneck link. It has shown that XCP can be implemented on a router at line-rate \cite{sharma17evaluating}. But XCP makes no assumption about the traffic characteristic. In this paper however we designed a network-centric TCP (NC-TCP) for interactive VDN where interactive video streaming competes among themselves. We have utilized the traffic characteristics to optimize throughput allocation. Here routers along the path calculate a sending rate based on PI controller in order to minimize the latency. Routers also divide the throughput fairly among the flows. Our experimental results show that such network centric approach results in small and smooth latency and better fairness in an interactive VDN.  

NC-TCP is designed as a rate-based congestion mechanism as opposed to XCP. It uses \textit{TCP-pacing} to regulate the sending rate. That is why, it does not send bursty traffic and it does not send more data than the network is able to deliver. NC-TCP also uses instantaneous queue backlog to calculate the feedback rate whereas XCP calculates the feedback rate based on the standing queue: minimum queue length over a control interval. This is why NC-TCP reacts to congestion quicker than XCP. Our experimental results show that NC-TCP performs better in containing small queue size compared to XCP in an interactive VDN. Our experimental results also shows that both NC-TCP and XCP preforms significantly better than delay-based congestion control, TCP Inigo in an interactive VDN.

Networked-centric congestion control has major advantage over traditional sender/receiver centric congestion control. Here the network controller has information about the competing flows and play an active role in regulating the flow rate. This is why the stability of the control system is easier to maintain compared to host centric approach where the controller of the system is distributed across the hosts. The centralized control system also facilitates to allocate the throughput fairly among the flows. Finally traditional host-based congestion control mechanism depends on implicit feedback such as delay-gradient and packet-loss to infer congestion. Contrary to that, NC-TCP uses actual network information to avoid the congestion.


NC-TCP has been initially proposed by the authors of this paper in a ICNP PVE-SDN workshop \cite{tamim}. However the initial work did not include dataplane NC-TCP implementation. NC-TCP protocol itself has been enhanced in this paper over the workshop paper. The main contributions of this paper are as following:
\begin{itemize}
	\item We have described the importance of TCP for interactive video video network (VDN). We have developed a network-centric TCP where rate is allocated by the routers along the path. We have shown that NC-TCP is stable and fair.
	\item We have described a dRMT based NPU. We have implemented NC-TCP for a hypothetical 256 core NPU where each core is 1 Ghz ARM Cortex-M3 processor. By analyzing the instruction set, we have found that the hypothetical router can achieve 4.7 Tb/s
	\item Today most of the interactive video streaming applications such as Google Hangout and Cisco telepresence application use delay based congestion control \cite{lundin2012google, zhu2013nada}. However our studies have shown that delay based congestion control algorithm perform very poorly compared to explicit rate control algorithm. We have shown that both NC-TCP and XCP outperform TCP Inigo which is a one-way delay variant based congestion control algorithm similar to the one used in Google Hangout \cite{lundin2012google}. 
\end{itemize}
			
\section{{Why TCP?}}
Interactive video streaming traditionally uses application layer rate control algorithm over UDP \cite{lundin2012google}. But this approach has some disadvantages. It forces the application developers to reimplement the common functionality. Different implementations of the congestion control algorithms interact poorly with each other, and the stability of the network is compromised. UDP is also not NAT and firewall friendly which are highly desirable attributes in today's Internet. TCP solves those problems,  however it has some disadvantages in the context of interactive video streaming. The ordered delivery of TCP delays some segment delivery if a prior segment is missing (\textit{head-of-line blocking } problem). Retransmission is also not often desirable in interactive video streaming. However it has shown that this problem can be avoided by modifying TCP implementation. Recently TCP Hollywood \cite{mcquistin2016tcp} has been designed as an unordered and time-line oriented TCP. It avoids the \textit{head-of-line blocking } problem by supporting unordered delivery. It also attaches a time-line to data. The data would be ignored after the time-line has been expired. This is how it avoids retransmission. Packet-loss can be further avoided by caching packets on the router. As NICs (network interface controllers) evolved from kbps to Gbps and memory chips from KB to GB, packet loss has become less of an issue.

\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{workflow}
	\caption{Work flow of NC-TCP}\label{workflow}
\end{figure}

\begin{figure}[!t]
	\centering
	\includegraphics[width=3cm]{im-option}
	\caption{NC option}\label{im-option}
\end{figure}

\section{NC-TCP Algorithm}
NC-TCP is implemented as a new TCP option. The option consists of two fields: \textit{expected throughput} and \textit{feedback throughput}. Figure \ref{im-option} show the NC option along the the option type and option length. TCP Option is the intended mechanism by which TCP can be extended. An empirical experiment has shown that it is possible to extend TCP by implementing a new option even though these packets go through plethora of middle-boxes \cite{honda2011still} . The workflow of NC-TCP is shown in Figure \ref{workflow}. A sender specifies the required throughput in SYN and DATA packets. The feedback throughput would be set by the routers. The routers allocate a feedback throughput based on the link bandwidth, number of flows and queue occupancy. Receivers copy the feedback throughput to the acknowledgements packets. In this way, the feedback throughput would be returned to the sender. This is how the routers send an explicit feedback throughput to the senders. The feedback throughput would be used as a sending rate in the sender. Traditional TCP uses window based congestion control. Window-based based congestion control produces bursty traffic. Video streaming traditionally uses rate-based congestion control \cite{lundin2012google}. NC-TCP has been designed as a rate-based congestion control. It uses \textit{TCP-pacing} \cite{aggarwal2000understanding} to regulate the sending rate.

A video streaming flow may have more than one bottleneck links along the path. All the bottleneck routers need to run the network controller in order to allocate a throughput to the flow. A bottleneck router would assign the feedback rate to the packets if the rate is smaller than the feedback calculated by a previous router. In this way, a more congested downstream router can further reduce this feedback by overwriting it. This ensures that the going rate of a sender is adjusted to the most congested link on the path.


\section{Congestion Control}
This section uses a \textit{Proportional Integral (PI)} controller in the router to calculate the aggregate feedback throughput based on the queue size. The routers also have a \textit{fairness} controller that divides the aggregate feedback throughput among the flows fairly. PI Enhanced (PIE) \cite{pan2013pie} controller has been  used in the Active Queue Management (AQM) techniques in the past. PIE uses Explicit Congestion Notification (ECN) to give a hint about the queuing delay. In contrast to that, NC-TCP uses the feedback throughput as a congestion signal. The feedback throughput from the router will be used as the sending rate of  the sender. We divide the feedback control system into two parts: Delay Controller and Fairness Controller.

\subsection{Delay Controller}
The delay controller is designed based on PI controller. It calculates the aggregate feedback throughput based queue length and link capacity. In PI controller, the aggregate feedback throughput can described by the following equation:

\begin{equation}\label{eq1} \sum r_i(t) = \alpha[c(t) - q(t)]\end{equation}

where the $\sum r_i(t)$ is the aggregate feedback throughput, $c(t)$ is the bottleneck link capacity, $q(t)$ is the queue length in bytes and $\alpha$ is the coefficient. We need to determine the value of $\alpha$ for which the system stabilizes. Later we have shown that the system stabilizes for when $\alpha > 0$. The value of $\alpha$ is used to regulate the queuing delay and throughput. There is a trade-off between throughput and queuing delay. Later we have shown that $\alpha=1$ makes the queuing delay approaches to zero at the same time maximizing the feedback throughput.

\subsection{Fairness Controller}
The objective of the fairness controller is to divide the capacity fairly among the flows. Here it uses min-max fairness to divide the available capacity among the flows equally. We can rewrite the equation (\ref{eq1}) as $r_i(t) = \frac{\alpha[c(t) - q(t)]}{N(t)}$ where $r_i(t)$ is the feedback throughput for flow $i$. 


\subsection{Stability Analysis}
This section shows that NC-TCP always converges to an equilibrium point. The feedback rate set by the router is sent back to the sender via acknowledgment. This is why there is a feedback delay in NC-TCP. Let us assume that the feedback delay is $t_f$. As the feedback rate becomes the sending rate after $t_f$,the sending rate at time $t$ can be written as
\begin{equation}\label{eq5}x_i(t) = \frac{\alpha [C - q(t - t_f)]}{N}\end{equation} Without loss of generality similar to all previous works \cite{katabi2002internet, dukkipati2007rate}, our analysis assumes that all flows have a common, finite, and positive round-trip delay and the link capacity and the number of flows  are constant for a session. The queuing-delay gradient can be represented as \begin{equation}\label{eq3}
\dot{q(t)} = \sum x_i(t) - C
\end{equation}
As flows adapt their sending rate $x_i(t)$ at the same rate, $\sum x_i(t) = N x_i(t)$ for all $i$. From equation (\ref{eq5}) and (\ref{eq3}) we get,  
\begin{equation}\label{eq4}
\dot{q(t)} = N x_i(t) - C \implies \dot{q(t)} = -\alpha q(t - t_f) + C(\alpha-1)
\end{equation}

This is an autonomous differential equation which describes the autonomous system. According to the stability theorem of autonomous differential equation, the system is stable if $\ddot{q(t^*)} < 0$ where $q(t^*)$ represents the queuing delay at the equilibrium point. This is why the system is stable if $\alpha > 0$. If the system is perturbed by burst of flows, the $q(t)$ increases. In that case, the queue will be drained at $-\alpha q(t - t_f) + C(\alpha-1)$ rate and eventually reaches the equilibrium point. 

At the equilibrium point, $\dot{q(t) = 0}$. Thus from the equation (\ref{eq4}), we get \begin{equation}\label{eq6}
q(t - t_f) = \frac{C(\alpha-1)}{\alpha}
\end{equation}
$\frac{C(\alpha-1)}{\alpha}$ is the queuing delay at the equilibrium point. The value of $\alpha$ controls the queuing delay and feedback throughput. Here we want the queuing delay to be be zero while maximizing the throughput. That is why we initialize $\alpha = 1$.  


\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{tandemqueue}
	\caption{Feedback throughput from each router is shown where actual link throughput is $X$. Here link utilization is less than 100\%}\label{tandemqueue}
\end{figure}

\subsection{Maximizing Link Utilization}
NC-TCP sets the feedback throughput based on the most congested link on the path. This however has a negative impact on link utilization. Figure \ref{tandemqueue} shows a topology where throughput of each link is $X$. The figure shows feedback throughputs from each router. Note that here $s1$ and $s2$ will receive feedback throughput $X/3$ and $X/2$ respectively. This is why link between $r1$ and $r2$ would be 75\% utilized. However in optimal allocation, $s1$ and $s2$ would receive feedback throughput $X/3$ and $2X/3$ respectively. NC-TCP solve this problem by adjusting $\alpha$ dynamically when queue occupancy is zero. When a link is underutilized, NC-TCP increases $\alpha$ gradually until the link utilization becomes 100\%. Again if router sees a long persistent queue, it decreases $\alpha$ till it become $1$. This is why $\alpha >= 1$. This is how NC-TCP maximizes the utilization by controlling $\alpha$. Note that such dynamic adjustment of $\alpha$ does not have negative impact on stability. If router allocate more throughput that it should, it may either be overwritten by a more congested router along the path or it itself will experience a long persistent queue. It latter scenario, the router will gradually decrease $\alpha$ to shrink the persistent queue.  


\section{Encoder Rate Control}
One of the main challenges of interactive video streaming is that the encoding rate of video cannot be changed quickly in order to avoid congestion. The video encoder reacts to encoding rate changes over discrete intervals which is usually more than 500 milliseconds. The actual encoder output rate also fluctuates randomly around the input target rate. The actual output rate of a video depends on the content of the video. This section shows how to set the target encoding rate based on the feedback rate.

The encoding rate in an adaptive video streaming is set based on the throughput of the network. Contrary to that, NC-TCP based application sets the target rate based on the feedback rate of the network. NC-TCP uses a rate-based congestion control mechanism to regulate the sending rate. It uses \textit{TCP-pacing} to regulate the sending rate. The sending rate is set to the feedback throughput. This is why NC-TCP does not send more data than network would be able to handle. As a result, although it results in a very small queuing delay, packets may wait in the TCP's sending buffer (congestion window) to be scheduled to sent out. This increases the RTT. This is why RTT produced by the NC-TCP is not exactly same as the propagation delay. Rather $RTT/RTT_{min}$ indicates how much encoder has overshot with respect to the network throughput. Here $RTT_{min}$ is the minimum RTT which is considered as the \textit{propagation delay}. We set the encoder target rate as 
\begin{displaymath}
R_t(t) = \frac{r_i(t)}{\frac{RTT}{RTT_{min}}}
\end{displaymath}
where $r_i(t)$ is the feedback throughput received from the network. Note that $\frac{RTT}{RTT_{min}} \geq 1$. This is why the target encoding rate is less than the feedback throughput. This is how NC-TCP based appliactions set the target encoding rate based on the network-feedback and past history of overshooting.  
 

 
 \begin {table}[H]
 \caption {Multicore CPU/NPU used for packet processing. '-' represents undisclosed} \label{npu} 
 \begin{center}
 	\begin{tabular}{ | m{11em} | m{.5cm}| m{.7cm}| m{1.8cm}| m{1.7cm}|} 
 		\hline CPU & \# of cores & Clock rate & Instruction set & Throughput \\ 
 		\hline Cisco QFP & 40  & 1.2GHz & -  & 100 Gbps \\		
 		\hline Cisco nPower X1 & 336  & - & -  & 400 Gbps \\
 		\hline Cisco unnamed NPU \cite{nPowerX2} & 672  & 1GHz & - & 400 Gbps \\		
 		\hline Mellanox NPS-400 & 256 & 1GHz & ARC 770D & 400Gbps	\\	
 		\hline Ericsson SNP 4000 & 256  & - & - & 	200 Gbps \\			
 		\hline Nokia FP3 & 288  & 1GHz & - & 400 Gbps \\  		 								 		
 		\hline Intel Xeon E5-2667 v4 & 8  & 3.2GHz & X86\_64 & 240 Gbps\cite{xeon}\\ 				 		  			
 		\hline Intel Xeon Platinum 8168 & 24  & 2.7GHz & X86\_64 & - \\	 		
 		\hline Qualcomm Centriq 2400 & 48 & 2.6GHz & ARM V8 & - \\ 		 		
 		\hline 
 	\end{tabular} 	
 \end{center}
 \end {table}

\section{Data plane design}
One of the main challenges of NC-TCP is data plane design. Recent advances in programmable router architectures such as RMT \cite{bosshart2013forwarding} and dRMT \cite{chole2017drmt} have enabled us to implement new protocols in dataplane. Recently XCP and RCP protocol have been implemented in RMT based switch \cite{sharma17evaluating}. In this paper however we have implemented NC-TCP dataplane for dRMT \cite{chole2017drmt} based switches. We begin this section by describing dMRT hardware and software packet processing. Then we have calculated processing cost for executing NC-TCP on dRMT router. 

\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{npu_router}
	\caption{Programmable routers with multicore processor and TCAM/SRAM}\label{npu_router}
\end{figure}


\subsection{Programmable Router}
 Although popular belief is  hardware switch is considerably faster than CPU, it has shown that multicore CPU also can achieve same throughput as hardware switch while achieve programmability with 10\% additional cost \cite{pongracz2013cheap}.  Programmable router architecture has received considerable attention in networking community. In RMT (Reconfigurable Match-action Table) \cite {bosshart2013forwarding} architecture, a programmable pipeline has been used to process and forward the packets. Example of RMT router is Barefoot Tofino \cite{tofino} and Cavium Xplaint \cite{xplaint}. RMT can be implemented on multicore CPU where a group of CPU cores execute each pipeline. Each core here has its own match-action table executes a part of the pipeline.  In Bosshart et el \cite{bosshart2013forwarding}, each core is 1GHz RISC-inspired processor uses TCAM to store match-action table. Actual implementation of Barefoot Tofino \cite{tofino} and Cavium Xplaint have not been revealed. 
 
 Recently Disaggregated RMT (dRMT) \cite{chole2017drmt} architecture also has been proposed where it uses multicore processor and a shared memory for packet processing. Although popular belief is that multicore processor with shared memory are slower and more expensive than programmable-pipeline (RMT model), it has shown that they can also achieve same throughput as programmable-pipeline without additional cost\cite{chole2017drmt,pongracz2013cheap}. Another great advantage of dRMT routers is they can be programmed in the same way as commodity hardware. In dRMT model, each core process packets in a run-to-completion model. Table \ref{npu} shows a list of notable CPUs used for packet processing. The processor cores of the CPU can run Linux and can be preprogrammed using general purpose C language.  \cite{mellanox, wheeler2013new}. 
  
Figure \ref{npu_router} shows a generalized hardware architecture of a NPU/CPU based dRMT router \cite{chole2017drmt, pongracz2013cheap, esilicon, qfp}. Packet processing requires L2/L3 header lookup in a routing/forwarding table. Such lookup is very expensive to be implemented on a processor core. Processor core uses TCAM/SRAM to accelerate such lookup. The TCAM can lookup IP header in one clock cycle \cite{esilicon, kuo2014memory}. On the other hand, in SRAM based approach, processor core uses Cuckoo a hash \cite{zhou2013scalable} on packet header to find the destination port in SRAM. TCAM/SRAM are connected to processor cores via a crossbar switch. The crossbar switch enables different processor cores to lookup the TCAM/SRAM simultaneously \cite{chole2017drmt}. 
 

\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{softwarepp}
	\caption{Packet processing in a programmable router}\label{softwarepp}
\end{figure} 

\subsection{Packet Processing in Software}
An operating system is generally used to manage system resources in a many-core router. However most of the todays OS does scale to multicore very efficiently. For example, SMP Linux often found under utilized in multi-core system. Linux kernel networking stack also cannot achieve required I/O throughput \cite{barbette2015fast}. This is why a separate application is used for packet processing. The packet-processing applications are pinned to each CPU such that it can monopolize the CPU. The Figure \ref{softwarepp} shows how packet processing applications and Linux divide the NPU cores among themselves. The OS represents the control plane and the packet processing applications represents dataplane. A Zero Overhead Linux (ZOL) \cite{zol, enea} a customized Linux where timers and interrupts are disabled and all but one the NPU cores are excluded from kernel scheduler. This refrains kernel from stealing CPU from the packet processing applications. This is why the packet processing applications can achieve bare-metal performance on each core. This also avoids TLB misses caused by context switching. Here userspace process on each core runs independently. Each core will have its own meta-data and packet header on which the core will operate. This is why there is no synchronization overhead. Such message passing is found more scalable than locking in massively multicore systems \cite{wentzlaff2010operating}.


Figure \ref{softwarepp} shows packet processing mechanism inside a programmable router. Each packet processing application allocates a circular queue buffer for both incoming (Rx queue) and outgoing (Tx queue) packets in DRAM. These buffers are circular queue descriptor where it contains incoming packet and meta-data. NICs distribute the incoming packets to the Rx buffers via DMA. They do it using Receiver Side Scaling (RSS)\footnote{https://www.kernel.org/doc/Documentation/networking/scaling.txt} mechanism. RSS mechanism is implemented in the NIC hardware where the NIC distributes the packet among Rx queues based on a flow hash. As there is one Rx buffer for each packet processing core, this is how incoming packets are distributed among the packet processing cores. NICs  also populate those buffer with meta-data such as queue size, number of flows and so on. NICs use memory-mapped IO to make those available in DRAM. Each packet processing core reads the packet header and meta-data from its Rx queue. The core is responsible the processing and forwarding the packet. The core does not however need the whole packet in its L1 cache. It only loads the packet header and meta-data on to the cache. It then processes the header and finds the destination port based on the TCAM entries. Finally it copies the packet to the Tx queue of the core. The DMA is responsible for copying the packet to outgoing port.  


\section{Data plane Programming}
Several dataplane programming frameworks have been developed for multi/many core routers. This include DPDK\footnote{http://dpdk.org/} and Linux NAPI \cite{busypolling}. Both DPDK and Linux NAPI avoids interrupts and use busy polling to process packets \cite{rizzo201210}. DPDK bypasses the kernel entirely and process packets in userspace. On the other hand, Linux NAPI processes packet inside kernel. DPDK and Linux NAPI follows many same design principle. In this section, we have described architectural design of both framework. 


\begin{figure*}[!t]	
	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=9cm]{dpdk}
		\caption{DPDK}\label{dpdk}
	\end{subfigure}%
	~ 
	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=9cm]{napi}
		\caption{Linux NAPI}\label{napi}
	\end{subfigure}%	 
	\caption{Comparison between DPDK and Linux NAPI}\label{dpdk_napi}
\end{figure*}

\subsection{DPDK (Data Plane Development Kit)}
DPDK is a set of libraries and drivers to implement packet forwarding on multicore  CPU. Figure \ref{dpdk} shows the architectural of DPDK. DPDK requires a modified version of Linux kernel that exposes NIC hardware to userspace. DPDK has a collection of userspace NIC drivers that are responsible for managing Rx and Tx ring buffers. DPDK  also has Environment Abstraction Layer (EAL) library that facilitate multicore programming. Packet processing application is developed based on EAL library. EAL creates userspace thread based on the number available CPU cores and execute each thread separately on each core. This is how each thread monopolizes the CPU core. There is also no context switch overhead. As each thread have separate ring buffer, they also do not need to hold lock.  

\subsection{Linux NAPI}
Linux New API (NAPI) is the high speed packet processing mechanism of Linux kernel. Figure \ref{dpdk_napi} shows the architectural difference between DPDK and Linux NAPI. Linux for being a monolithic kernel prefers the drivers to be placed inside kernel. In Linux NAPI, kernel NIC drivers are responsible for managing Rx and Tx ring buffers. Linux kernel also creates kernel thread based on the available core. The kernel threads are responsible to processing packets in a run-completion model. 
 
 \begin {table}[H]
 \caption {DPDK and NAPI supported NICs and corresponding drivers} \label{nics} 
 \begin{center}
 	\begin{tabular}{ | m{13em} | m{2.1cm}| } 
 		\hline NIC & Driver \\ 
 		\hline Intel XL710 & i40e   \\ 		
 		\hline Mellanox ConnectX-4 & mlx5   \\ 		
 		\hline Netronome NFP & nfp    \\ 		 	
 		\hline Broadcom NetXtreme-C/E & bnxt   \\
 		\hline QLogic FastLinQ QL4xxxx & qede  \\	 			 		
 		\hline 		 
 	\end{tabular} 	
 \end{center}
 \end {table}
\subsection{Busy polling driver}
Table \ref{nics} shows a list of 40-100 Gbps NICs supported by both DPDK and Linux NAPI. These NICs supports RSS scaling, multi-queue and checksum offloading which are needed for high speed packet forwarding. NIC manufacturer generally provide driver in order for their NIC to be used with DPDK and NAPI. The table also shows the driver that needs to be enabled in order to use the NIC.

NICs are generally connected to CPU via PCI express (PCIe) bus. The NIC driver is responsible for communicating to NIC from CPU. PCIe devices have a 4KB standard configuration space that is exposed to CPU via memory mapped IO. The NIC driver communicates to NIC by reading and writing to the configuration space. The NIC driver allocates Tx and Rx ring buffer in DRAM to be used by NIC DMA. It then updates  Interrupts is disabled in those mechanism except at the beginning. Once the first packet is received, interrupt is disabled. DPDK and XDP has poll mode driver (PMD) and NAPI to fetch packet   The packet processing framework is responsible for allocating Tx and Rx queue descriptor. Those queue descriptor would be populated by NIC.   There are several restriction in data plane programming. Here packet processing application userspace programs cannot use any system call as the kernel is running on a separate core. The usespace application also does not hold any lock. Finally interrupts are disabled in this mechanism so that packet processing application can run without any interruption. The userspace application needs to use a poll-mode driver to pull up packet header and meta-data. DPDK (Data Plane Development Kit) is a packet processing framework that achieve such goal.

\subsection{{Processing cost of NC-TCP}}
In this section, we have evaluated the processing cost of NC-TCP for a 1GHz ARM Cortex-M3 \cite{m3} processor. This ARM core has been used to design a 256 core hypothetical NPU in \cite{pongracz2013cheap}. Here we have shown the assembly code of NC-TCP for ARM Cortex-M3 processor. We also have calculated the number of CPU cycles needed for NC-TCP.

\begin{enumerate}
	\item Parsing TCP option header (in L1 cache) and load \textit{feedback throughput} on to a CPU register:
	\begin{verbatim}
		Register $1: packet-header pointer
		Register $feedback: Result 
		Code: 
		LDR $feedback, [$1, <offset>] 
	\end{verbatim} 
	 So it takes just one instruction to parse TCP option header. The instruction takes 2 clock cycles. This is the feedback throughput set by a previous router along the path.
	\item Load the number of flows and current queue queue size on to register from L1 cache:
	\begin{verbatim}
	Register $1: meta-data pointer
	Register $num: number of flows 
	Register $queue: current queue size
	Code: 
	LDR $num, [$1, <offset>] 
	LDR $queue, [$1, <offset>] 
	\end{verbatim}
	Those instructions will take 4 clock cycles.		
	\item Calculate a feedback throughput. Set the feedback throughput if it is smaller than the current feedback throughput.
	\begin{verbatim}
	Register $1: packet-header pointer	
	Register $capacity: Link capacity
	Register $feedback:	current option header feedback
	Register $thput: Result
	Code:
	#Calculate feedback throughput in $thput
	SUB $thput, $capacity, $queue
	SDIV $thput, $thput, $num
	#Set the feedback if $thput < $feedback 
	CMP $feedback, $thput
	BLEQ exit
	STR $thput, [$1, <offset>]
	exit
	\end{verbatim}
	SUB, CMP and BLEQ need 1 clock cycle each. SDIV takes 2-12 cycles based on the values. And finally STR takes 2 clock cycle and 1 memory access. This is why this step needs 6-16 clock cycles and 1 memory write latency.	The on-chip DRAM write requires a fixed access latency + write latency \cite{pongracz2013cheap}. This is equivalent to 5-20 clock cycles in a 1GHz processor. This is why this step will take at most 36 cycle. 
\end{enumerate}


The processing steps of NC-TCP shows that each packet take 42 CPU cycles. Programmable routers use TCAM to lookup IP prefix. TCAM can lookup IP header in one clock cycle \cite{kuo2014memory}. As parsing an IPv4 header takes only 2 cycle, so finding the destination port and updating the header will take 23 cycles at most. This is why each packet can be processed in 65 cycles in a ARM Cortex-M3. The result would be similar for similar RISC processors. Note that in our model, packet header was prefetched into L1 cache by the DMA controller and packet would be sent to destination port by the the packet scheduler core (Figure \ref{softwarepp}). This is why those cost are not included in packet processing cost. 

Here we have estimated the worst case packet processing cost for each packet. As each packet takes 65 cycles, a 1GHz ARM Cortex-M3, it can process 1.53 million packets per second. If each packet is 1500 byte, one core can achieve 18.36 Gbps throughput. Thus a 256 core NPU can achieve 4.7 Tb/s.

\section{Implementation}
We have implemented NC-TCP and XCP in Linux kernel\footnote{https://github.com/tamimcse/Linux}. We also have found that TCP Inigo Linux kernel implementation in the Internet \footnote{https://github.com/systemslab/tcp\_inigo}. Our software architecture for the both NC-TCP and XCP includes two parts: NC-TCP host and NC-TCP router.

NC-TCP end point is implemented by adding a new option to Linux TCP stack. In contrast to the traditional TCP, NC-TCP uses \textit{TCP-pacing} \cite{aggarwal2000understanding} to regulate the sending rate. Here the sending rate is set to the feedback rate received from the network. The congestion window is also set $\frac{r_i(t) * RTT}{MSS}$ where $MSS$ represents the \textit{maximum segment size}. Linux TCP stack does not have a native \textit{TCP-pacing} implementation. TCP-pacing has been implemented using \textit{fq} (fair queue) Qdisc (queuing discipline). Qdisc is the traffic control mechanism in the Linux kernel. XCP on the other hand uses window based congestion control. XCP sender calculates the congestion window based on the feedback received from the XCP router.

NC-TCP router has been implemented in the Linux router as a new Qdisc kernel module. We have used Linux router by enabling the \textit{ip\_forward} option in Linux. The Qdisc kernel module inspects the NC-TCP option and sets a feedback rate based on the delay and fairness controller. XCP router is also implemented in the same manner where the rate in calculated based on the controller described in \cite{katabi2002internet}. 


\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{topology}
	\caption{Topology}\label{topology}
\end{figure}



\begin{figure*}[!t]
	\vspace{-5\baselineskip}
	\begin{subfigure}[t]{\textwidth}
		\includegraphics[width=9cm]{h1-throughput}
		\includegraphics[width=9cm]{backlog}
	\end{subfigure}
	\begin{subfigure}[t]{\textwidth}
		\vspace{-3\baselineskip}
		\includegraphics[width=9cm]{h1-rtt}
		\includegraphics[width=9cm]{fairness}
	\end{subfigure}%
	\vspace{-3\baselineskip}	
	\caption{Comparison among NC-TCP, XCP and TCP Inigo in an interactive VDN}\label{im-cubuc}
\end{figure*}

\section{Experimental Setup}
We have created a topology as Figure \ref{topology} using Mininet \cite{lantz2010network}. We have used \textit{NetEm} Qdisc to set the delay and \textit{htb} (hierarchical token bucket) Qqisc to set the throughputs on the network interfaces\footnote{http://lartc.org/}. We verified the throughput and latency of our setup using \textit{ping} and \textit{iperf}. We have run our experiment on a laptop running Ubuntu 16.04 with our modified Linux kernel 4.9.0. The laptop has a core i7 processor with four cores and 16GB memory.

We also developed a GStreamer\footnote{https://gstreamer.freedesktop.org/} based application\footnote{https://github.com/tamimcse/gst-streamer} in C to stream video from the sources. The source nodes act as a TCP server and the sink nodes act as a TCP client. Once the connection has been established, the server streams video to the client. In this experiment, we used a clip from Big Buck Bunny\footnote{http://bbb3d.renderfarming.net/download.html}.  The source application produces \textit{512X340} video at 30 fps.  This video is encoded into H.264 format. Here we used adaptive bitrate streaming where the bitrate of the video is adapted based on the network throughput. We used one-pass constant bitrate (CBR) encoder to produce the desired bitrate. Such one-pass encoder is traditionally used for real-time streaming. The GStreamer source updates the encoding rate in every 500 milliseconds. It uses \textit{getsockopt} system call to get feedback throughput from the TCP stack. It updates the encoding rate based on the feedback. On the receiving side, each node has a GStreamer sink application that plays the video as soon as a new NAL (network abstraction layer) unit is received.     


\section{Evaluation}
This section compared the performance of NC-TCP with other delay based TCP. Loss-based TCP such as TCP CUBIC \cite{ha2008cubic} results in substantial delay in the router which is not acceptable for interactive traffic. Recently Google proposed congestion based congestion control, TCP BBR \cite{45646} which adjusts the sending rate by probing the network. But it also results in substantial queuing delay in our in our experimental test-bed which makes it unsuitable for interactive video streaming. We found TCP CDG \cite{hayes2011revisiting} and TCP Inigo \cite{shewmaker2016tcp} to cause very small queuing delay which make them suitable for interactive video streaming. Moreover we found that TCP Inigo outperforms TCP CDG in achieving higher throughput and lower latency. This is why, in this section we compared the performance of NC-TCP with that of TCP Inigo. This section also compared NC-TCP with XCP \cite{katabi2002internet}. XCP and RCP \cite{dukkipati2007rate} are explicit rate control mechanism which are promising alternative to TCP. RCP is designed to minimize the flow completion time but it results in higher queuing delay \cite{dukkipati2007rate}. This is why RCP is not suitable for interactive video streaming. XCP on the other hand results in very small queuing delay. This is why we also compared NC-TCP to that of XCP. This section compared the performance of one-way flows in order to avoid the reverse path affect. 


\begin{figure*}[!t]

	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=9cm]{flows-inigo}
		\vspace{-3\baselineskip}
		\caption{Three TCP Inigo flows 15 seconds apart}\label{flows-cdg}
	\end{subfigure}%
	~ 
	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=9cm]{flows-im}
		\vspace{-3\baselineskip}
		\caption{Three NC-TCP flows 15 seconds apart}\label{flows-im}
	\end{subfigure}%	 
	\caption{NC-TCP and TCP Inigo self-fairness comparison}\label{fairness}
\end{figure*}

The primary evaluation criteria in this section are the queuing delay on the bottleneck router and the throughput fairness. As NC-TCP, XCP and TCP Inigo fully utilize the bottleneck link, higher fairness indicates that all the flows get higher throughput while lower fairness indicates that some flows get higher throughput while other flows are not receiving higher throughput from the bottleneck link. 

\textbf{Single bottleneck link}: We have conducted our experiment on the topology describe in Figure \ref{topology}. In the experiment, we have started three flows simultaneously and let it run for 80 seconds. We have run the experiment for NC-TCP, XCP and TCP Inigo separately. We have shown the throughput, queuing delay, round-trip time and Jain's fairness index in Figure \ref{im-cubuc}. We have modified the \textit{tcp\_probe} kernel module to record throughput and RTT on the sender. Here \textit{tcp\_probe} takes sample as soon as the congestion window changes. The network-controller we developed also records the queue backlog  using Linux \textit{proc} file system.  


\begin{figure*}[!t]
	\vspace{-3\baselineskip}
	\begin{subfigure}[!t]{\textwidth}
		\includegraphics[width=9cm]{rtt/backlog}
		\includegraphics[width=9cm]{rtt/fairness}		
	\end{subfigure}
	\vspace{-2\baselineskip}	
	\caption{Evaluating RTT fairness for three flows with different RTTs in interactive VDN}\label{rtt-fairness}
\end{figure*}


\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{parkinglot}
	\caption{Parking lot topology with multiple bottleneck links}\label{parkinglot}
\end{figure}


\begin{figure*}[!t]
	\vspace{-3\baselineskip}
	\begin{subfigure}[!t]{\textwidth}
		\includegraphics[width=9cm]{parkinglot/backlog}
		\includegraphics[width=9cm]{parkinglot/fairness}		
	\end{subfigure}
	\vspace{-2\baselineskip}	
	\caption{Comparison among NC-TCP, XCP and TCP Inigo in an interactive VDN with multiple bottleneck links}\label{parkinglotres}
\end{figure*}

The Figure \ref{im-cubuc} shows that both NC-TCP and XCP produces smooth throughput. Such smooth throughput of is very suitable for adaptive video streaming. On the other hand, the throughput of TCP Inigo fluctuates very rapidly compared to NC-TCP and XCP. 

The Figure \ref{im-cubuc} has also shown the queuing delay of the bottleneck router. The queuing delay has been calculated using $\frac{q(t)}{B} $ where $B$ is the bottleneck throughput. The figure shows that NC-TCP outperforms XCP and TCP Inigo in queuing delay. TCP Inigo regulates the sending rate based on the delay-gradient observed on the receiver. It has no real network information. It rather tries to estimate the extent of congestion based on the implicit information, the delay observed on the receiver. NC-TCP on the other hand regulates the sending rate based on the actual congestion information. This is why NC-TCP performs significantly better than TCP Inigo. The figure also shows that XCP produces spikes in queuing delay. This is because it uses standing queue in rate calculation. Standing queue is the minimum queue backlog during a control interval. XCP also uses window-based congestion control which causes bursty traffic in the bottleneck router. NC-TCP on the other hand uses instantaneous queue backlog in rate calculation. This is why it reacts sooner to congestion than XCP. NC-TCP also use \textit{TCP-pacing} to regulate the sending rate. This is why, it does not send bursty traffic to network. 






The Figure \ref{im-cubuc} also compared the smoothed RTT (SRTT) experienced by the protocols. It shows that NC-TCP outperforms TCP Inigo and XCP in reducing SRTT. Note that, average RTT in our experimental test-bed is 140 milliseconds. The round-trip time produced by NC-TCP is also close to 140 milliseconds. It is also noteworthy that although queuing delay in NC-TCP is close to zero, the RTT is not equal to the propagation delay. This is because NC-TCP segments may wait in the sender buffer before being scheduled by the \textit{TCP-pacing} Qdisc.  


Finally the Figure \ref{im-cubuc} has compared the Jain's fairness index for the protocols. The Jain's fairness index has been calculated using the formula $\frac{{(\sum_{i=1}^{n} x_i)}^2}{n \sum_{i=1}^{n} {x_i}^2}$ where $x_i$ is the throughput of flow $i$ and $n$ is the total number of flows. Higher fairness index indicates that the protocol is better in fairness. The figure shows that both NC-TCP and XCP outperforms TCP Inigo in fairness. It is noteworthy that although XCP exhibits occasional downward spikes in fairness index, it performs very fairly most of the time. Both NC-TCP and XCP divides the bottleneck throughput equally among the flows. This results in very high fairness index. On the contrary, TCP Inigo results in very fluctuating queuing delay which cause the congestion window to fluctuate even more. As a result, TCP Inigo performs poorly in fairness compared to XCP and NC-TCP. Note that low fairness results in lower throughput to some flows which results in lower QoE for interactive video streaming. 





\textbf{Self-fairness}: Here we have examined the self fairness of NC-TCP and TCP Inigo. We have run the experiment again where each flow is 15 seconds apart. Figure \ref{fairness} shows three flows competing for 1Mbps bottleneck link. Figure \ref{flows-cdg} shows that without the present of other flows, TCP Inigo can utilize the available throughput. But it performs poorly when it starts competing with other flows. It changes the congestion window rapidly based on the queuing delay caused by other flows. This is why throughput also fluctuates rapidly. Contrary to that, NC-TCP divides the available throughput fairly among the flows. This is why NC-TCP flows get fair throughput from the bottleneck link. Figure \ref{flows-im} shows that NC-TCP also able to utilize the available throughput in the absence of other flows. It also shows that when three NC-TCP shares a bottleneck link, they get nearly fair amount of throughput from the bottleneck link. The throughput also does not fluctuates as much as TCP Inigo which results in better QoE for adaptive video streaming. 

\textbf{RTT-fairness:} The throughput allocation of NC-TCP does not depend on the RTTs of the flows. To evaluate the RTT-fairness of NC-TCP, we have modified the topology in Figure \ref{topology} such that the three different flows have different RTTs:  80ms, 100ms and 120ms. Figure \ref{rtt-fairness} shows the queuing delay and fairness index for the topology. It shows that NC-TCP is fair to flows with different RTTs. NC-TCP is also able to contain the queuing delay in the presence of different RTT flows  (as Figure \ref{rtt-fairness}). This is why even though the feedback-delays are different for each flow, they receive smooth feedback throughput. On the other hand, XCP and TCP Inigo exhibit spikes in queuing delay. This is why they also exhibit variability in fairness index. 

\textbf{Multiple bottleneck links:} Figure \ref{parkinglot} shows a topology with multiple bottleneck links and the flows. Here the links connecting two routers are the bottleneck links. The links connecting a router and a host are the access links. The throughput of bottleneck and access links are 660kbps and 1024kbps respectively. The propagation delays of the links are shown in the figure. We also have introduced 2ms and 3ms delay variance on the access links and bottleneck links respectively. We conducted the same experiment as before on this topology. Here four flows are started simultaneously on the source nodes. We let the experiment run for 80 seconds. Figure \ref{parkinglotres} compared performance of NC-TCP to that of TCP Inigo and XCP. The figures shows that both NC-TCP and XCP is very effective in containing queuing delay whereas Inigo results in very high queuing delay in the presence of multiple bottlenecks. NC-TCP also outperforms XCP and Inigo in fairness index. 


\textbf{Differential fairness}: Interactive VDN needs to support heterogeneous endpoints such as smart phones, laptops, TV and VR headset at the same time. The videos used in different endpoints often differ in encodings, resolutions and frame rates. This is why different endpoints may need different throughputs. Network-centric congestion control has a major advantage in this regard. As a router is aware of the throughput requirement of each flow passing through it, it can apply differential fairness in throughput allocation. NC-TCP option (Figure \ref{im-option}) has \textit{expected throughput} field which would be used by the senders to specify their throughput requirements. Bottleneck router can apply weighted fairness based on the \textit{expected throughput} in allocating throughput to each flow.

\textbf{Visual Interruption}: Visual interruption is the situation where video player on a receiver enters into a buffering mode. Such interruption degrades the QoE significantly. Table \ref{visual} shows the number of visual interruptions experienced for different topologies. It shows that both NC-TCP and XCP performs significantly well compared to TCP Inigo. 

\begin {table}[H]
\caption {Number of visual interruptions} \label{visual} 
\begin{center}
	\begin{tabular}{ | m{5em} | m{3cm}| m{3cm} | } 
		\hline
		& Single bottleneck & Multiple bottleneck\\ 
		\hline
		TCP Inigo & 2 & 20 \\ 
		\hline
		XCP & 0 & 0 \\ 
		\hline
		NC-TCP & 0 & 0 \\		
		\hline
	\end{tabular}
\end{center}
\end {table}

\section{Conclusions}
This paper presents a router-centric TCP (NC-TCP) for interactive video delivery network (VDN). Here the interactive video streaming applications compete for the network resources among themselves. The sending-rate of NC-TCP is determined by the routers along the path. The routers use a PI-controller in order to minimize the latency. The router also provides min-max fairness by dividing the feedback throughput fairly among the flows. Our analysis has shown that such NC-TCP is stable and produces very smooth outgoing rate and lower latency. We have implemented NC-TCP in the Linux kernel as a new TCP option. NC-TCP is also designed based on TCP-pacing rather than congestion window. We have evaluated NC-TCP in Mininet testbed. Our experimental results show that NC-TCP produces very smooth and fair throughput and low latency. Our experimental results also show that NC-TCP outperforms TCP Inigo in interactive VDN. NC-TCP also outperforms XCP is containing small queuing delay in interactive VDN. Another important outcome of this paper is that it shows although latency based congestion control algorithms have been widely used in many real-world interactive video streaming applications, they perform very poorly compared to NC-TCP and XCP. Finally we have implemented NC-TCP for NPU. Our instruction set analysis shows that NC-TCP on NPU can achieve sufficient throughput to be deployed on a real network. 



% trigger a \newpage just before the given reference
% number - used to balance the columns on the last page
% adjust value as needed - may need to be readjusted if
% the document is modified later
%\IEEEtriggeratref{8}
% The "triggered" command can be changed if desired:
%\IEEEtriggercmd{\enlargethispage{-5in}}

% references section

% can use a bibliography generated by BibTeX as a .bbl file
% BibTeX documentation can be easily obtained at:
% http://www.ctan.org/tex-archive/biblio/bibtex/contrib/doc/
% The IEEEtran BibTeX style support page is at:
% http://www.michaelshell.org/tex/ieeetran/bibtex/
%\bibliographystyle{IEEEtran}
% argument is your BibTeX string definitions and bibliography database(s)
%\bibliography{IEEEabrv,../bib/paper}
%
% <OR> manually copy in the resultant .bbl file
% set second argument of \begin to the number of references
% (used to reserve space for the reference number labels box)
%
% As suggested below, edit bibtemplate_samples.bib to reflect
% your bibliography. See bibtemplate.text for referencing.
%

\bibliographystyle{IEEEtran}
\bibliography{bibtemplate_samples}





% that's all folks
\end{document}


